package xyz.lychee.lagfixer.objects;

import org.bukkit.Bukkit;
import xyz.lychee.lagfixer.LagFixer;
import xyz.lychee.lagfixer.managers.HookManager;

public abstract class AbstractHook {
   private final LagFixer plugin;
   private final HookManager manager;
   private boolean loaded = false;

   public AbstractHook(LagFixer plugin, HookManager manager) {
      this.plugin = plugin;
      this.manager = manager;
   }

   public boolean isEnabled() {
      return Bukkit.getPluginManager().getPlugin(this.plugin()) != null;
   }

   public abstract void load() throws Exception;

   public abstract void disable() throws Exception;

   public abstract String plugin();

   public LagFixer getPlugin() {
      return this.plugin;
   }

   public HookManager getManager() {
      return this.manager;
   }

   public boolean isLoaded() {
      return this.loaded;
   }

   public void setLoaded(boolean loaded) {
      this.loaded = loaded;
   }
}
